# Windowise

## Live Demos & Docs
[https://gao-sun.github.io/windowise](https://gao-sun.github.io/windowise)

## Unified

We have different kinds of windows in our webpage. Windowise helps you to have unified UI style and manage them in an easy way!

## Promise-based

Windowise is a Promise-based library, and Promise has been supported by [all modern browsers](http://caniuse.com/#feat=promises). It helps you to avoid callback hells and write more readable codes.

## Get Started

1.Install via npm
```bash
npm install windowise
```

```js
// In JavaScript
import { Window, Modal, Nft, Push, Progress, Input } from 'windowise';
import Style from 'windowise/dist/windowise.css';
```

2.CDN

```html
<link rel="stylesheet" href="https://unpkg.com/windowise@latest/dist/windowise.min.css">
<script src="https://unpkg.com/windowise@latest/dist/windowise.min.js"></script>
```

3.Download from dist/ in Github repository

## Contributing

Please leave an issue if you find any bugs, I will fix it ASAP.

Please read the simple [guideline](https://gao-sun.github.io/windowise/#guideline) before you develop your own component which is based on Windowise.