/*! Windowise - v1.0.4 | Gao Sun | MIT | https://gao-sun.github.io/windowise/ */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["Windowise"] = factory();
	else
		root["Windowise"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 12);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _button = __webpack_require__(10);

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Utility = {};

Utility.createElement = function (tag, className, innerHTML, attributes) {
	var dom = document.createElement(tag);

	className && (dom.className = className);
	innerHTML && (dom.innerHTML = innerHTML);
	if (attributes) {
		for (var i in attributes) {
			dom.setAttribute(i, attributes[i]);
		}
	}

	return dom;
};

Utility.createDiv = function (className, innerHTML, attributes) {
	return Utility.createElement('div', className, innerHTML, attributes);
};

Utility.createDomTree = function (tree) {
	if (!tree || !tree.hasOwnProperty('dom')) {
		return tree;
	}

	var dom = tree.dom;

	if (tree.children) {
		for (var i in tree.children) {
			if (!tree.children[i]) {
				continue;
			}

			dom.appendChild(Utility.createDomTree(tree.children[i]));
		}
	}

	return dom;
};

Utility.removeElement = function (dom) {
	dom != null && dom.parentNode.removeChild(dom);
};

Utility.appendToBody = function (dom) {
	document.body.appendChild(dom);
};

Utility.makeIconHTML = function (type) {
	var href = '';

	type == 'ok' && (href = '#tick');
	type == 'error' && (href = '#cancel');
	type == 'info' && (href = '#info-button');
	type == 'caution' && (href = '#danger');
	type == 'min' && (href = '#line');
	type == 'close' && (href = '#close');

	return '<svg class="icon ' + type + '"><use xlink:href="' + href + '" /></svg>';
};

Utility.makeNftContent = function (options) {
	var content = null;

	if (options.type) {
		var innerContent = null;

		if (typeof options.content === 'string') {
			innerContent = Utility.createDiv('inner-content', options.content);
		} else {
			innerContent = Utility.createDomTree({
				dom: Utility.createDiv('inner-content'),
				children: [options.content]
			});
		}

		if (options.type == 'text') {
			content = Utility.createDomTree({
				dom: Utility.createDiv('content text'),
				children: [innerContent]
			});
		} else {
			content = Utility.createDomTree({
				dom: Utility.createDiv('content'),
				children: [Utility.createDiv('state', Utility.makeIconHTML(options.type)), innerContent]
			});
		}
	} else if (typeof options.content === 'string') {
		content = Utility.createDiv('content', options.content);
	}

	return content;
};

Utility.standardizeButtons = function (modal, options) {
	var buttons = [];

	if (options.buttons === undefined) {
		if (options.type == 'caution' || options.type == 'info') {
			buttons.push({
				key: 27,
				text: 'Cancel',
				onClick: modal.close.bind(modal, 'cancel')
			});
		}

		buttons.push({
			key: 13,
			text: 'OK',
			type: 'main',
			onClick: modal.close.bind(modal, 'ok')
		});

		return buttons;
	}

	buttons = options.buttons;

	if (!(buttons.constructor === Array)) {
		buttons = [buttons];
	}

	for (var i in buttons) {
		!buttons[i].onClick && (buttons[i].onClick = modal.close.bind(modal, buttons[i].id));
	}

	return buttons;
};

Utility.makeButtons = function (buttonArr) {
	var buttons = [];

	if (buttonArr) {
		for (var i in buttonArr) {
			buttons.push(_button2.default.create({
				text: buttonArr[i].text ? buttonArr[i].text : 'OK',
				type: buttonArr[i].normal ? null : 'main',
				onClick: buttonArr[i].onClick
			}));
		}
	}

	return Utility.createDomTree({
		dom: Utility.createDiv('button-wrapper'),
		children: buttons
	});
};

Utility.bindButtonKeyEvents = function (buttonArr) {
	var handler = function handler(event) {
		for (var i in buttonArr) {
			if (buttonArr[i].key === event.keyCode) {
				buttonArr[i].onClick();
				return;
			}
		}
	};
	window.addEventListener('keydown', handler);
	return handler;
};

Utility.unbindButtonKeyEvents = function (handler) {
	window.removeEventListener('keydown', handler);
};

exports.default = Utility;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _animatorjs = __webpack_require__(3);

var _animation = __webpack_require__(9);

var _animation2 = _interopRequireDefault(_animation);

var _utility = __webpack_require__(0);

var _utility2 = _interopRequireDefault(_utility);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var defaultOptions = {
	animation: 'pop',
	topbar: {
		showClose: true,
		showMin: false
	},
	keepOverlay: false,
	position: 'center',
	overlay: false,
	clickOverlayToClose: true,
	removeBackground: false,
	noRadius: false,
	zIndex: null
};

var Window = function () {
	_createClass(Window, null, [{
		key: 'create',
		value: function create(dom, options) {
			var title = dom.getElementsByClassName('title')[0];
			title && (title = title.innerHTML);
			var content = dom.getElementsByClassName('content')[0];
			content && (content = content.innerHTML);

			_utility2.default.removeElement(dom);

			options.title = title;
			options.content = content;

			return new Window(options);
		}
	}]);

	function Window(options) {
		_classCallCheck(this, Window);

		// Init options
		this.options = JSON.parse(JSON.stringify(defaultOptions));
		for (var i in options) {
			options[i] != undefined && (this.options[i] = options[i]);
		}

		var position = this.options.position;
		if (position.indexOf(' ') == -1) {
			if (position == 'left' || position == 'right') {
				position = position + ' center';
			} else if (position == 'top' || position == 'bottom') {
				position = 'center ' + position;
			} else {
				position = position + ' ' + position;
			}
		}
		this.options.position = position;

		// Overlay
		if (this.options.overlay) {
			var cuurentOverlay = document.getElementsByClassName('wwise-overlay');

			if (cuurentOverlay.length) {
				this.overlay = cuurentOverlay[0];
				this.hasOverlay = true;
			} else {
				this.overlay = _utility2.default.createDiv('wwise-overlay');
				this.options.zIndex && (this.overlay.style.zIndex = this.options.zIndex);
			}

			this.overlayClickHandler = this.close.bind(this, undefined);
		} else {
			this.options.clickOverlayToClose = false;
		}

		// Topbar
		var contentClassName = 'content';
		if (this.options.topbar) {
			// Topbar Controls
			var controls = [];

			if (this.options.topbar.showMin) {
				controls.push(_utility2.default.createDiv(null, _utility2.default.makeIconHTML('min')));
				controls[controls.length - 1].addEventListener('click', this.min.bind(this));
			}

			if (this.options.topbar.showClose) {
				controls.push(_utility2.default.createDiv(null, _utility2.default.makeIconHTML('close')));
				controls[controls.length - 1].addEventListener('click', this.close.bind(this, undefined));
			}

			var titleDom = null;

			if (typeof this.options.title === 'string') {
				titleDom = _utility2.default.createDiv('title', this.options.title);
			} else {
				titleDom = _utility2.default.createDomTree({
					dom: _utility2.default.createDiv('title'),
					children: [this.options.title]
				});
			}

			this.topbar = _utility2.default.createDomTree({
				dom: _utility2.default.createDiv('topbar'),
				children: [{
					dom: _utility2.default.createDiv('control'),
					children: controls.map(function (value) {
						return { dom: value };
					})
				}, {
					dom: titleDom
				}, {
					dom: _utility2.default.createDiv('clear')
				}]
			});
		} else {
			contentClassName += ' no-topbar';
		}

		// Content
		if (typeof this.options.content === 'string') {
			this.content = _utility2.default.createDomTree({
				dom: _utility2.default.createDiv(contentClassName, this.options.content)
			});
		} else {
			this.content = _utility2.default.createDomTree({
				dom: _utility2.default.createDiv(contentClassName),
				children: [this.options.content]
			});
		}
		this.options.removeBackground && (this.content.style.background = 'initial');

		// Window
		this.window = _utility2.default.createDomTree({
			dom: _utility2.default.createDiv('wwise' + (this.options.noRadius ? ' no-radius' : '')),
			children: [this.topbar, this.content]
		});

		// Wrapper
		var wrapperDom = _utility2.default.createDiv('wwise-wrapper');

		this.options.zIndex && (wrapperDom.style.zIndex = this.options.zIndex);
		this.wrapper = _utility2.default.createDomTree({
			dom: wrapperDom,
			children: [this.window]
		});

		// Whole DOM
		this.dom = _utility2.default.createDomTree({
			dom: _utility2.default.createDiv(),
			children: [this.wrapper]
		});

		// Position
		var positions = this.options.position.split(' ');
		var translateX = -50,
		    translateY = -50;

		if (positions[0] == 'left') {
			translateX = 0;
			this.wrapper.classList.add('left');
		} else if (positions[0] == 'right') {
			translateX = -100;
			this.wrapper.classList.add('right');
		} else if (positions[0] == 'center') {
			this.wrapper.classList.add('h-center');
		} else {
			this.wrapper.style.left = positions[0];
		}

		if (positions[1] == 'top') {
			translateY = 0;
			this.wrapper.classList.add('top');
		} else if (positions[1] == 'bottom') {
			translateY = -100;
			this.wrapper.classList.add('bottom');
		} else if (positions[1] == 'center') {
			this.wrapper.classList.add('v-center');
		} else {
			this.wrapper.style.top = position[1];
		}

		this.window.style.transform = 'translate(' + translateX + '%, ' + translateY + '%)';

		if (this.options.style) {
			for (var _i in this.options.style) {
				this.window.style[_i] = this.options.style[_i];
			}
		}

		if (this.options.margin) {
			this.wrapper.style.margin = this.options.margin;
		}

		// Draggable
		if (this.options.draggable) {
			this.draggable();
		}
	}

	_createClass(Window, [{
		key: 'open',
		value: function open(fromMin) {
			var _this = this;

			if (this.opened) {
				return;
			}

			this.promise = new Promise(function (resolve) {
				_this.promiseResolve = resolve;
			});
			this.appendDoms();
			this.opened = true;

			if (this.options.clickOverlayToClose) {
				this.overlay.addEventListener('click', this.overlayClickHandler);
			}

			var animation = fromMin ? 'min' : this.options.animation;

			if (animation) {
				if (animation == 'min' || animation == 'flip') {
					this.dom.classList.add('wwise-perspective');
				}

				var q = [new _animatorjs.Queue(this.wrapper, _animation2.default[animation + '_in'], { instant: true, applyOnEnd: true }).getPromise()];

				if (this.options.overlay && !this.hasOverlay) {
					q.push(new _animatorjs.Queue(this.overlay, _animation2.default.overlay_in, { instant: true, applyOnEnd: true }).getPromise());
				}

				return Promise.all(q).then(function () {
					_this.dom.classList.remove('wwise-perspective');
				});
			}

			return Promise.resolve();
		}
	}, {
		key: 'close',
		value: function close(toMin) {
			var _this2 = this;

			if (!this.opened) {
				return;
			}

			this.opened = false;

			var animation = toMin ? 'min' : this.options.animation;

			this.overlay && this.overlay.removeEventListener('click', this.overlayClickHandler);

			if (animation) {
				if (animation == 'min' || animation == 'flip') {
					this.dom.classList.add('wwise-perspective');
				}

				var q = [new _animatorjs.Queue(this.wrapper, _animation2.default[animation + '_out'], { instant: true, applyOnEnd: true }).getPromise()];

				if (this.options.overlay && !this.options.keepOverlay) {
					q.push(new _animatorjs.Queue(this.overlay, _animation2.default.overlay_out, { instant: true, applyOnEnd: true }).getPromise());
				}

				return Promise.all(q).then(function () {
					_this2.removeDoms();
					_this2.dom.classList.remove('wwise-perspective');
					_this2.promiseResolve();
				});
			}

			this.removeDoms();
			this.promiseResolve();
			return Promise.resolve();
		}
	}, {
		key: 'min',
		value: function min() {
			return this.close(true);
		}
	}, {
		key: 'resume',
		value: function resume() {
			return this.open(true);
		}
	}, {
		key: 'getPromise',
		value: function getPromise() {
			return this.promise;
		}
	}, {
		key: 'appendDoms',
		value: function appendDoms() {
			if (this.options.overlay && !this.hasOverlay) {
				_utility2.default.appendToBody(this.overlay);
				document.body.classList.add('wwise-no-scroll');
				this.overlay.addEventListener('touchstart', function (event) {
					event.preventDefault();
				});
			}
			_utility2.default.appendToBody(this.dom);
		}
	}, {
		key: 'removeDoms',
		value: function removeDoms() {
			_utility2.default.removeElement(this.dom);
			if (!this.options.keepOverlay && this.overlay) {
				_utility2.default.removeElement(this.overlay);
				document.body.classList.remove('wwise-no-scroll');
			}
		}

		// Draggable functions

	}, {
		key: 'draggable',
		value: function draggable() {
			var enabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

			if (!this.topbar) {
				return;
			}

			if (enabled) {
				this.draggableMouseMoveHandler = this.handleDraggableMouseMove.bind(this);
				this.draggableMouseDownHandler = this.handleDraggableMouseDown.bind(this);
				this.draggableMouseUpHandler = this.handleDraggableMouseUp.bind(this);
				this.draggableMouseOutHandler = this.handleDraggableMouseOut.bind(this);

				window.addEventListener('mousemove', this.draggableMouseMoveHandler);
				window.addEventListener('mouseout', this.draggableMouseOutHandler);
				this.topbar.addEventListener('mousedown', this.draggableMouseDownHandler);
				window.addEventListener('mouseup', this.draggableMouseUpHandler);
			} else {
				window.removeEventListener('mousemove', this.draggableMouseMoveHandler);
				window.removeEventListener('mouseout', this.draggableMouseOutHandler);
				this.topbar.removeEventListener('mousedown', this.draggableMouseDownHandler);
				window.removeEventListener('mouseup', this.draggableMouseUpHandler);
			}
		}
	}, {
		key: 'handleDraggableMouseMove',
		value: function handleDraggableMouseMove(event) {
			if (this.inDragging) {
				var delta = { x: event.clientX - this.dragPrev.x, y: event.clientY - this.dragPrev.y };
				var style = window.getComputedStyle(this.wrapper);
				var option = this.options.draggable;
				var left = parseFloat(style.left);
				var top = parseFloat(style.top);

				// Handle percentage for Safari
				// http://stackoverflow.com/questions/22034989/is-there-a-bug-in-safari-with-getcomputedstyle
				if (style.left.indexOf('%') != -1) {
					left = style.left;
					left = left.substr(0, left.length - 1);
					left = parseInt(left);

					var w = window,
					    d = document,
					    e = d.documentElement,
					    g = d.getElementsByTagName('body')[0],
					    width = w.innerWidth || e.clientWidth || g.clientWidth;

					left = left * width / 100;
				}

				if (style.top.indexOf('%') != -1) {
					top = style.top;
					top = top.substr(0, top.length - 1);
					top = parseInt(top);

					var _w = window,
					    _d = document,
					    _e = _d.documentElement,
					    _g = _d.getElementsByTagName('body')[0],
					    height = _w.innerHeight || _e.clientHeight || _g.clientHeight;

					top = top * height / 100;
				}

				// Move
				if (option == true || option == 'horizontal') {
					this.wrapper.style.left = left + delta.x + 'px';
				}

				if (option == true || option == 'vertical') {
					this.wrapper.style.top = top + delta.y + 'px';
				}

				this.dragPrev = { x: event.clientX, y: event.clientY };
			}
		}
	}, {
		key: 'handleDraggableMouseDown',
		value: function handleDraggableMouseDown(event) {
			this.inDragging = true;
			this.dragPrev = { x: event.clientX, y: event.clientY };
		}
	}, {
		key: 'handleDraggableMouseUp',
		value: function handleDraggableMouseUp(event) {
			this.inDragging = false;
		}
	}, {
		key: 'handleDraggableMouseOut',
		value: function handleDraggableMouseOut(event) {
			var target = event.relatedTarget;

			if (!target || target.nodeName == 'HTML') {
				this.inDragging = false;
			}
		}
	}]);

	return Window;
}();

exports.default = Window;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utility = __webpack_require__(0);

var _utility2 = _interopRequireDefault(_utility);

var _window = __webpack_require__(1);

var _window2 = _interopRequireDefault(_window);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Modal = function () {
	function Modal(__options) {
		_classCallCheck(this, Modal);

		var options = this.options = __options;

		!options.type && (options.type = 'ok');

		var wwiseOptions = {};

		wwiseOptions.topbar = false;
		wwiseOptions.content = this.constructContent({
			type: options.type,
			title: options.title,
			text: options.text,
			content: options.content,
			buttons: options.buttons
		});
		wwiseOptions.overlay = true;
		wwiseOptions.keepOverlay = options.keepOverlay;
		wwiseOptions.clickOverlayToClose = false;
		wwiseOptions.animation = options.animation;
		wwiseOptions.zIndex = options.zIndex;

		this.wwise = new _window2.default(wwiseOptions);
	}

	_createClass(Modal, [{
		key: 'constructContent',
		value: function constructContent(options) {
			var dom = _utility2.default.createDiv('modal');
			var main = _utility2.default.createDomTree({
				dom: _utility2.default.createDiv('main ' + options.type),
				children: [_utility2.default.createDiv(null, _utility2.default.makeIconHTML(options.type)), _utility2.default.createDiv('title', options.title), _utility2.default.createDiv('text', options.text)]
			});

			this.buttonArr = _utility2.default.standardizeButtons(this, options);
			var buttons = _utility2.default.makeButtons(this.buttonArr);

			// Content
			var content = null;
			if (options.content) {
				if (typeof options.content === 'string') {
					content = _utility2.default.createDiv(null, options.content);
				} else {
					content = options.content;
				}
			}

			// Operations
			var operation = null;

			if (buttons.innerHTML) {
				operation = _utility2.default.createDomTree({
					dom: _utility2.default.createDiv('operation ' + options.type),
					children: [buttons]
				});
			}

			// Border radius
			if (!content && !operation) {
				main.classList.add('no-op');
			}

			return _utility2.default.createDomTree({
				dom: dom,
				children: [main, content, operation]
			});
		}
	}, {
		key: 'open',
		value: function open() {
			var _this = this;

			if (this.wwise.opened) {
				return;
			}

			var f = this.wwise.open();

			this.value = undefined;
			this.promise = new Promise(function (resolve) {
				_this.promiseResolve = resolve;
			});
			this.wwise.getPromise().then(this.handlePromiseResolve.bind(this));
			this.keyHandler = _utility2.default.bindButtonKeyEvents(this.buttonArr);

			if (this.options.closeAfter) {
				window.setTimeout(function () {
					_this.close('timer');
				}, this.options.closeAfter);
			}

			return f;
		}
	}, {
		key: 'close',
		value: function close(value) {
			if (!this.wwise.opened) {
				return;
			}

			this.value = value;
			_utility2.default.unbindButtonKeyEvents(this.keyHandler);
			return this.wwise.close();
		}
	}, {
		key: 'getPromise',
		value: function getPromise() {
			return this.promise;
		}
	}, {
		key: 'handlePromiseResolve',
		value: function handlePromiseResolve() {
			this.promiseResolve(this.value);
		}
	}]);

	return Modal;
}();

exports.default = Modal;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

/*! Animator.js - v1.0.2 | Gao Sun | MIT | https://gao-sun.github.io/animatorjs */
(function webpackUniversalModuleDefinition(root, factory) {
	if(true)
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["Animator"] = factory();
	else
		root["Animator"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 5);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});
var Style = {};

Style.convertToObject = function (style) {
	var str = style.substring(style.indexOf('{') + 1).trim().slice(0, -1);
	var obj = {};

	str.split(';').map(function (value) {
		value = value.trim();

		if (!value) {
			return;
		}

		var tmp = value.split(':');

		obj[tmp[0].trim()] = tmp[1].trim();
	});

	return obj;
};

Style.getFromSheets = function (selector) {
	var sheets = document.styleSheets;

	for (var i in sheets) {
		var classes = null;

		try {
			classes = sheets[i].rules || sheets[i].cssRules;
		} catch (e) {}

		if (!classes) {
			continue;
		}

		for (var x in classes) {
			if (classes[x].selectorText && classes[x].selectorText.split(',').indexOf(selector) != -1) {
				if (classes[x].cssText) {
					return Style.convertToObject(classes[x].cssText);
				} else {
					return Style.convertToObject(classes[x].style.cssText);
				}
			}
		}
	}

	return {};
};

Style.getPropertyDefault = function (name) {
	if (name == 'timing-function') {
		return 'ease';
	}

	if (name == 'iteration-count') {
		return 1;
	}

	if (name == 'direction') {
		return 'normal';
	}

	if (name == 'fill-mode') {
		return 'none';
	}

	return null;
};

exports.default = Style;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});
var Utility = {};

Utility.generateId = function () {
	var id = '';
	var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';

	for (var i = 0; i < 8; ++i) {
		id += possible.charAt(Math.floor(Math.random() * possible.length));
	}

	return id;
};

Utility.frameToString = function (frame) {
	var str = '';

	for (var i in frame) {
		str += i + ':' + frame[i] + ';';
	}

	return str;
};

Utility.convertTimeToMs = function (time) {
	if (!time) {
		return 0;
	}

	if (typeof time === 'number') {
		return time;
	}

	var ret = parseFloat(time);

	if (time.indexOf('ms') != -1) {
		return ret;
	}

	return ret * 1000;
};

Utility.prefixes = ['', '-webkit-', '-moz-', '-o-'];

exports.default = Utility;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _style = __webpack_require__(0);

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Frame = function Frame(styles, options) {
	_classCallCheck(this, Frame);

	if (typeof styles === 'string') {
		this.styles = _style2.default.getFromSheets(styles);
	} else {
		this.styles = styles;
	}

	if (typeof options === 'string') {
		var tmp = _style2.default.getFromSheets(options);
		this.options = {};

		for (var i in tmp) {
			this.options[i.replace('animation-', '')] = tmp[i];
		}
	} else if (typeof options === 'number') {
		this.options = { duration: options };
	} else {
		this.options = options;
	}
};

exports.default = Frame;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _animation = __webpack_require__(4);

var _animation2 = _interopRequireDefault(_animation);

var _utility = __webpack_require__(1);

var _utility2 = _interopRequireDefault(_utility);

var _style = __webpack_require__(0);

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Queue = function () {
	function Queue(doms, frames, options, extra) {
		_classCallCheck(this, Queue);

		if (doms.constructor === Array) {
			this.doms = doms;
		} else {
			this.doms = [doms];
		}

		if (frames.constructor === Array) {
			this.frames = frames;
		} else {
			this.frames = [frames];
		}

		this.options = {
			startFrom: 0,
			pauseAt: [],
			prefix: false,
			count: 1,
			clear: true,
			applyOnEnd: false,
			instant: false
		};

		if (options != null && options != undefined) {
			if (typeof options === 'boolean') {
				this.options['instant'] = options;
			} else if (typeof options === 'number') {
				this.options['count'] = options;

				if (typeof extra === 'boolean') {
					this.options['instant'] = extra;
				}
			} else {
				for (var i in options) {
					if (i == 'pauseAt' && !(options.pauseAt.constructor === Array)) {
						this.options[i] = [options[i]];
					} else {
						this.options[i] = options[i];
					}
				}
			}
		}

		// Init
		this.promiseSupported = typeof Promise !== "undefined" && Promise.toString().indexOf("[native code]") !== -1;
		this.countRemainder = [];
		this.animations = [];
		this.styleDoms = [];
		this.superSets = [];
		this.eventHandler = [];

		if (this.options.prefix) {
			this.prefixes = _utility2.default.prefixes;
		} else {
			this.prefixes = [''];
		}

		for (var _i in doms) {
			this.countRemainder[_i] = this.options.count - 1;
		}

		if (this.options.instant) {
			this.play();
		}
	}

	// Controllers


	_createClass(Queue, [{
		key: 'play',
		value: function play() {
			var _this = this;

			this.clear();

			if (this.promiseSupported) {
				this.promise = new Promise(function (resolve) {
					_this.promiseResolve = resolve;
				});
			}

			for (var i in this.doms) {
				var animation = this.makeAnimation(this.doms[i]);

				this.animations[i] = animation.names;
				this.styleDoms[i] = animation.styleDom;
				this.superSets[i] = this.makeSuperSet(this.doms[i], this.animations[i]);
				this.playAnimation(this.doms[i], this.superSets[i]);

				this.eventHandler[i] = this.handleAnimationEnd.bind(this, i);
				this.doms[i].addEventListener('animationend', this.eventHandler[i]);
			}

			if (this.promiseSupported) {
				return this.promise;
			}
		}
	}, {
		key: 'clear',
		value: function clear(i) {
			if (!i) {
				for (var _i2 in this.doms) {
					this.clear(_i2);
				}

				this.animationEnded = 0;
				this.promise = undefined;
				this.promiseResolve = undefined;

				return;
			}

			var dom = this.styleDoms[i];

			if (dom && dom.parentNode) {
				dom.parentNode.removeChild(dom);
			}

			for (var j in this.superSets[i]) {
				for (var k in this.prefixes) {
					this.doms[i].style[this.prefixes[k] + 'animation-' + j] = null;
				}
			}

			for (var _k in this.prefixes) {
				this.doms[i].style[this.prefixes[_k] + 'animation-play-state'] = null;
			}

			this.doms[i].removeEventListener('animationend', this.eventHandler[i]);
			this.countRemainder[i] = this.options.count - 1;
		}
	}, {
		key: 'replay',
		value: function replay(index) {
			var dom = this.doms[index];
			var newDom = dom.cloneNode(true);

			dom.parentNode.replaceChild(newDom, dom);
			this.doms[index].removeEventListener('animationend', this.eventHandler[index]);
			this.doms[index] = newDom;
			this.doms[index].addEventListener('animationend', this.eventHandler[index]);
		}
	}, {
		key: 'pause',
		value: function pause() {
			for (var i in this.doms) {
				this.pauseDom(this.doms[i]);
			}
		}
	}, {
		key: 'resume',
		value: function resume() {
			for (var i in this.doms) {
				this.resumeDom(this.doms[i]);
			}
		}
	}, {
		key: 'getPromise',
		value: function getPromise() {
			return this.promise;
		}

		// Assistants

	}, {
		key: 'handleAnimationEnd',
		value: function handleAnimationEnd(domIndex, event) {
			var name = event.animationName;
			var index = name.substring(name.lastIndexOf('-') + 1);

			if (this.options.pauseAt.includes(parseInt(index))) {
				this.pauseDom(this.doms[domIndex]);
			}

			if (index == this.frames.length) {
				if (this.countRemainder[domIndex] == -1) {
					this.replay(domIndex);
				} else if (this.countRemainder[domIndex] > 0) {
					this.countRemainder[domIndex]--;
					this.replay(domIndex);
				} else {
					if (this.options.applyOnEnd) {
						this.applyOnEnd(domIndex);
					}

					this.animationEnded++;

					if (this.animationEnded == this.doms.length) {
						if (this.promiseSupported) {
							this.promiseResolve();
						}

						if (this.options.clear) {
							this.clear();
						}
					}
				}
			}
		}
	}, {
		key: 'pauseDom',
		value: function pauseDom(dom) {
			for (var i in this.prefixes) {
				dom.style[this.prefixes[i] + 'animation-play-state'] = 'paused';
			}
		}
	}, {
		key: 'resumeDom',
		value: function resumeDom(dom) {
			for (var i in this.prefixes) {
				dom.style[this.prefixes[i] + 'animation-play-state'] = 'running';
			}
		}
	}, {
		key: 'applyOnEnd',
		value: function applyOnEnd(index) {
			var lastFrame = this.newFrames[this.frames.length];

			for (var i in lastFrame) {
				this.doms[index].style[i] = lastFrame[i];
			}
		}
	}, {
		key: 'makeAnimation',
		value: function makeAnimation(dom) {
			var initial = {};
			var frames = [];
			var superSet = {};

			for (var i in this.frames) {
				frames.push(this.frames[i].styles);

				for (var j in frames[i]) {
					superSet[j] = true;
				}
			}

			// Make initial frame
			var originalStyle = window.getComputedStyle(dom);
			for (var _i3 in superSet) {
				initial[_i3] = originalStyle[_i3];
			}

			frames.unshift(initial);

			var newFrames = [frames[0]];

			// Make new frames
			for (var _i4 = 1; _i4 < frames.length; ++_i4) {
				var newFrame = JSON.parse(JSON.stringify(newFrames[_i4 - 1]));

				for (var _j in frames[_i4]) {
					newFrame[_j] = frames[_i4][_j];
				}

				newFrames.push(newFrame);
			}

			this.newFrames = newFrames;

			return _animation2.default.make(newFrames, this.prefixes);
		}
	}, {
		key: 'makeSuperSet',
		value: function makeSuperSet(dom, animations) {
			var currentDelay = 0;

			// Init Superset
			var superSet = {};

			for (var i in this.frames) {
				for (var j in this.frames[i].options) {
					superSet[j] = '';
				}
			}

			superSet['name'] = '';
			superSet['duration'] = '';
			superSet['delay'] = '';

			// Start Generation
			for (var _i5 = 0; _i5 < this.frames.length; ++_i5) {
				if (_i5) {
					for (var _j2 in superSet) {
						superSet[_j2] += ',';
					}
				}

				var time = _utility2.default.convertTimeToMs(this.frames[_i5].options.duration);
				var delay = _utility2.default.convertTimeToMs(this.frames[_i5].options.delay);

				if (_i5 < this.options.startFrom) {
					time = 0;
					delay = 0;
				}

				superSet['name'] += animations[_i5];
				superSet['duration'] += time + 'ms';
				superSet['delay'] += currentDelay + delay + 'ms';

				for (var _j3 in superSet) {
					if (_j3 != 'name' && _j3 != 'duration' && _j3 != 'delay') {
						superSet[_j3] += this.frames[_i5].options[_j3] ? this.frames[_i5].options[_j3] : _style2.default.getPropertyDefault(_j3);
					}
				}

				var count = this.frames[_i5].options['iteration-count'];

				currentDelay += time * parseInt(count ? count : 1) + delay;
			}

			return superSet;
		}
	}, {
		key: 'playAnimation',
		value: function playAnimation(dom, superSet) {
			for (var i in superSet) {
				for (var j in this.prefixes) {
					dom.style[this.prefixes[j] + 'animation-' + i] = superSet[i];
				}
			}

			if (this.options.pauseAt.includes(0)) {
				this.pauseDom(dom);
			}
		}
	}]);

	return Queue;
}();

exports.default = Queue;

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _utility = __webpack_require__(1);

var _utility2 = _interopRequireDefault(_utility);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Animation = {};

Animation.make = function (frames, prefixes) {
	var names = [];
	var html = '';
	var namePrefix = 'atr-' + _utility2.default.generateId();
	var style = document.createElement('style');

	for (var i = 0; i < frames.length - 1; ++i) {
		names.push(namePrefix + '-' + (i + 1));
		html += Animation.makeFromTwoFrames(frames[i], frames[i + 1], names[i], prefixes);
	}

	style.innerHTML = html;
	style.class = "foo";
	document.getElementsByTagName('head')[0].appendChild(style);

	return { names: names, styleDom: style };
};

Animation.makeFromTwoFrames = function (f1, f2, name, prefixes) {
	var keyFrames = '';

	for (var i in prefixes) {
		keyFrames += '@' + prefixes[i] + 'keyframes ' + name + ' {';
		keyFrames += '0%';
		keyFrames += '{' + _utility2.default.frameToString(f1) + '}';
		keyFrames += '100%';
		keyFrames += '{' + _utility2.default.frameToString(f2) + '}';
		keyFrames += '}';
	}

	return keyFrames;
};

exports.default = Animation;

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Queue = exports.Frame = undefined;

var _frame = __webpack_require__(2);

var _frame2 = _interopRequireDefault(_frame);

var _queue = __webpack_require__(3);

var _queue2 = _interopRequireDefault(_queue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.Frame = _frame2.default;
exports.Queue = _queue2.default;

/***/ })
/******/ ]);
});

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utility = __webpack_require__(0);

var _utility2 = _interopRequireDefault(_utility);

var _modal = __webpack_require__(2);

var _modal2 = _interopRequireDefault(_modal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var defaultOptions = {
	showCancel: false,
	okText: 'OK',
	cancelText: 'Cancel',
	placeholder: '',
	validator: null
};

var defaultWwiseOptions = {
	type: 'info',
	keepOverlay: false,
	title: 'Input',
	text: '',
	zIndex: null
};

var Input = function () {
	function Input(__options) {
		_classCallCheck(this, Input);

		// Init options
		this.options = JSON.parse(JSON.stringify(defaultOptions));
		for (var i in __options) {
			__options[i] != undefined && (this.options[i] = __options[i]);
		}

		var options = this.options;
		var wwiseOptions = JSON.parse(JSON.stringify(defaultWwiseOptions));

		for (var _i in wwiseOptions) {
			options.hasOwnProperty(_i) && (wwiseOptions[_i] = options[_i]);
		}

		// Buttons
		var buttons = [];

		if (options.showCancel) {
			buttons.push({ key: 27, text: options.cancelText, normal: true, onClick: this.handleCancel.bind(this) });
		}

		buttons.push({ key: 13, text: options.okText, onClick: this.handleOk.bind(this) });
		wwiseOptions.buttons = buttons;

		// Input
		this.input = _utility2.default.createElement('input', 'input', null, { placeholder: options.placeholder });
		this.error = _utility2.default.createDiv('error');

		wwiseOptions.content = _utility2.default.createDomTree({
			dom: _utility2.default.createDiv('input-wrapper'),
			children: [this.input, this.error]
		});

		this.modal = new _modal2.default(wwiseOptions);
	}

	_createClass(Input, [{
		key: 'handleCancel',
		value: function handleCancel() {
			this.close().then(this.promiseReject.bind(this));
		}
	}, {
		key: 'handleOk',
		value: function handleOk() {
			var _this = this;

			if (this.options.validator) {
				this.options.validator(this.input.value).then(function () {
					_this.close().then(_this.promiseResolve.bind(_this, _this.input.value));
				}, function (msg) {
					_this.error.innerText = msg;
				});

				return;
			}

			this.close().then(this.promiseResolve.bind(this, this.input.value));
		}
	}, {
		key: 'open',
		value: function open() {
			var _this2 = this;

			if (this.modal.wwise.opened) {
				return;
			}

			var f = this.modal.open();
			this.input.value = '';
			this.error.innerText = '';
			this.input.focus();
			this.promise = new Promise(function (resolve, reject) {
				_this2.promiseResolve = resolve;
				_this2.promiseReject = reject;
			});

			return f;
		}
	}, {
		key: 'close',
		value: function close() {
			if (!this.modal.wwise.opened) {
				return;
			}

			return this.modal.close();
		}
	}, {
		key: 'getPromise',
		value: function getPromise() {
			return this.promise;
		}
	}]);

	return Input;
}();

exports.default = Input;

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utility = __webpack_require__(0);

var _utility2 = _interopRequireDefault(_utility);

var _window = __webpack_require__(1);

var _window2 = _interopRequireDefault(_window);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var defaultOptions = {
	type: null,
	animation: 'right',
	position: 'right top',
	showClose: true,
	clickToClose: false,
	closeAfter: null
};

var Nft = function () {
	function Nft(__options) {
		_classCallCheck(this, Nft);

		this.options = JSON.parse(JSON.stringify(defaultOptions));
		for (var i in __options) {
			__options[i] != undefined && (this.options[i] = __options[i]);
		}

		this.closeHandler = this.close.bind(this);

		var options = this.options;
		var wwiseOptions = {};

		wwiseOptions.topbar = false;
		wwiseOptions.content = this.constructContent(options);
		wwiseOptions.overlay = false;
		wwiseOptions.animation = options.animation;
		wwiseOptions.position = options.position;
		wwiseOptions.style = options.style;
		wwiseOptions.margin = '10px 15px';
		wwiseOptions.removeBackground = true;
		wwiseOptions.zIndex = options.zIndex;

		this.wwise = new _window2.default(wwiseOptions);
	}

	_createClass(Nft, [{
		key: 'constructContent',
		value: function constructContent(options) {
			var dom = _utility2.default.createDiv('nft' + (options.type && options.type != 'text' ? ' preset ' + options.type : ''));

			// Content
			var content = _utility2.default.makeNftContent(options);

			var close = null;
			if (options.showClose) {
				close = _utility2.default.createDomTree({
					dom: _utility2.default.createDiv('close'),
					children: [_utility2.default.createDiv(null, _utility2.default.makeIconHTML('close'))]
				});

				close.addEventListener('click', this.closeHandler);
			}

			if (options.clickToClose) {
				dom.addEventListener('click', this.closeHandler);
			}

			return _utility2.default.createDomTree({
				dom: dom,
				children: [content, close]
			});
		}
	}, {
		key: 'open',
		value: function open() {
			var _this = this;

			if (this.wwise.opened) {
				return;
			}

			var f = this.wwise.open();

			this.promise = new Promise(function (resolve) {
				_this.promiseResolve = resolve;
			});
			this.wwise.getPromise().then(this.promiseResolve);

			if (this.options.closeAfter) {
				window.setTimeout(function () {
					_this.close();
				}, this.options.closeAfter);
			}

			return f;
		}
	}, {
		key: 'close',
		value: function close() {
			if (!this.wwise.opened) {
				return;
			}

			return this.wwise.close();
		}
	}, {
		key: 'getPromise',
		value: function getPromise() {
			return this.promise;
		}
	}]);

	return Nft;
}();

exports.default = Nft;

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utility = __webpack_require__(0);

var _utility2 = _interopRequireDefault(_utility);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Progress = function () {
	function Progress(options) {
		_classCallCheck(this, Progress);

		options === undefined && (options = {});

		var background = null;

		if (options.percentage) {
			options.color && (background = options.color);

			this.bar = _utility2.default.createDiv('bar');
			this.dom = _utility2.default.createDomTree({
				dom: _utility2.default.createDiv('wwise-progress'),
				children: [this.bar]
			});
		} else {
			options.color && (background = 'linear-gradient(to right, rgba(221, 221, 221, 0), ' + options.color + ', rgba(221, 221, 221, 0))');

			this.bar = _utility2.default.createDiv('wait');
			this.dom = _utility2.default.createDomTree({
				dom: _utility2.default.createDiv('wwise-progress'),
				children: [this.bar]
			});
		}

		this.bar.style.background = background;
	}

	_createClass(Progress, [{
		key: 'set',
		value: function set(value) {
			value > 100 && (value = 100);
			this.bar.style.width = value + '%';
		}
	}]);

	return Progress;
}();

exports.default = Progress;

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utility = __webpack_require__(0);

var _utility2 = _interopRequireDefault(_utility);

var _window = __webpack_require__(1);

var _window2 = _interopRequireDefault(_window);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var defaultOptions = {
	type: null,
	textAlign: 'center',
	clickToClose: false,
	closeAfter: null,
	buttons: undefined
};

var defaultWwiseOptions = {
	position: 'top',
	overlay: false,
	clickOverlayToClose: false,
	style: null,
	zIndex: null
};

var Push = function () {
	function Push(__options) {
		_classCallCheck(this, Push);

		this.options = JSON.parse(JSON.stringify(defaultOptions));
		for (var i in __options) {
			__options[i] != undefined && (this.options[i] = __options[i]);
		}

		this.closeHandler = this.close.bind(this, 'click');

		var options = this.options;
		var wwiseOptions = JSON.parse(JSON.stringify(defaultWwiseOptions));

		options.buttons === undefined && (options.buttons = []);

		for (var _i in wwiseOptions) {
			options.hasOwnProperty(_i) && (wwiseOptions[_i] = options[_i]);
		}

		wwiseOptions.topbar = false;
		wwiseOptions.content = this.constructContent(options);
		wwiseOptions.animation = wwiseOptions.position;
		wwiseOptions.removeBackground = true;

		this.wwise = new _window2.default(wwiseOptions);
	}

	_createClass(Push, [{
		key: 'constructContent',
		value: function constructContent(options) {
			var dom = _utility2.default.createDiv('push' + (options.type && options.type != 'text' ? ' preset ' + options.type : ''));

			dom.style.textAlign = options.textAlign;

			// Content
			var content = _utility2.default.makeNftContent(options);

			var append = options.append ? typeof options.append === 'string' ? _utility2.default.createDiv(null, options.append) : options.append : null;

			this.buttonArr = _utility2.default.standardizeButtons(this, options);
			var buttons = _utility2.default.makeButtons(this.buttonArr);

			!buttons.innerHTML && (buttons = null);

			if (options.clickToClose) {
				dom.addEventListener('click', this.closeHandler);
			}

			return _utility2.default.createDomTree({
				dom: dom,
				children: [content, append, buttons]
			});
		}
	}, {
		key: 'open',
		value: function open() {
			var _this = this;

			if (this.wwise.opened) {
				return;
			}

			var f = this.wwise.open();

			this.promise = new Promise(function (resolve) {
				_this.promiseResolve = resolve;
			});
			this.wwise.getPromise().then(this.handlePromiseResolve.bind(this));
			this.keyHandler = _utility2.default.bindButtonKeyEvents(this.buttonArr);

			if (this.options.closeAfter) {
				window.setTimeout(function () {
					_this.close('timer');
				}, this.options.closeAfter);
			}

			return f;
		}
	}, {
		key: 'close',
		value: function close(value) {
			if (!this.wwise.opened) {
				return;
			}

			this.value = value;
			_utility2.default.unbindButtonKeyEvents(this.keyHandler);
			return this.wwise.close();
		}
	}, {
		key: 'getPromise',
		value: function getPromise() {
			return this.promise;
		}
	}, {
		key: 'handlePromiseResolve',
		value: function handlePromiseResolve() {
			this.promiseResolve(this.value);
		}
	}]);

	return Push;
}();

exports.default = Push;

/***/ }),
/* 8 */
/***/ (function(module, exports) {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" style=\"display: none;\"><symbol id=\"line\" viewBox=\"0 0 491.858 491.858\"><title>line</title><path d=\"M465.167,211.613H240.21H26.69c-8.424,0-26.69,11.439-26.69,34.316s18.267,34.316,26.69,34.316h213.52h224.959 c8.421,0,26.689-11.439,26.689-34.316S473.59,211.613,465.167,211.613z\"/></symbol><symbol id=\"cancel\" viewBox=\"0 0 300.003 300.003\"><title>cancel</title><path d=\"M150,0C67.159,0,0.001,67.159,0.001,150c0,82.838,67.157,150.003,149.997,150.003S300.002,232.838,300.002,150 C300.002,67.159,232.839,0,150,0z M206.584,207.171c-5.989,5.984-15.691,5.984-21.675,0l-34.132-34.132l-35.686,35.686 c-5.986,5.984-15.689,5.984-21.672,0c-5.989-5.991-5.989-15.691,0-21.68l35.683-35.683L95.878,118.14 c-5.984-5.991-5.984-15.691,0-21.678c5.986-5.986,15.691-5.986,21.678,0l33.222,33.222l31.671-31.673 c5.986-5.984,15.694-5.986,21.675,0c5.989,5.991,5.989,15.697,0,21.678l-31.668,31.671l34.13,34.132 C212.57,191.475,212.573,201.183,206.584,207.171z\"/></symbol><symbol id=\"close\" viewBox=\"0 0 47.971 47.971\"><title>close</title><path d=\"M28.228,23.986L47.092,5.122c1.172-1.171,1.172-3.071,0-4.242c-1.172-1.172-3.07-1.172-4.242,0L23.986,19.744L5.121,0.88 c-1.172-1.172-3.07-1.172-4.242,0c-1.172,1.171-1.172,3.071,0,4.242l18.865,18.864L0.879,42.85c-1.172,1.171-1.172,3.071,0,4.242 C1.465,47.677,2.233,47.97,3,47.97s1.535-0.293,2.121-0.879l18.865-18.864L42.85,47.091c0.586,0.586,1.354,0.879,2.121,0.879 s1.535-0.293,2.121-0.879c1.172-1.171,1.172-3.071,0-4.242L28.228,23.986z\"/></symbol><symbol id=\"tick\" viewBox=\"0 0 191.667 191.667\"><title>tick</title><path d=\"M95.833,0C42.991,0,0,42.99,0,95.833s42.991,95.834,95.833,95.834s95.833-42.991,95.833-95.834S148.676,0,95.833,0z M150.862,79.646l-60.207,60.207c-2.56,2.56-5.963,3.969-9.583,3.969c-3.62,0-7.023-1.409-9.583-3.969l-30.685-30.685 c-2.56-2.56-3.97-5.963-3.97-9.583c0-3.621,1.41-7.024,3.97-9.584c2.559-2.56,5.962-3.97,9.583-3.97c3.62,0,7.024,1.41,9.583,3.971 l21.101,21.1l50.623-50.623c2.56-2.56,5.963-3.969,9.583-3.969c3.62,0,7.023,1.409,9.583,3.969 C156.146,65.765,156.146,74.362,150.862,79.646z\"/></symbol><symbol id=\"danger\" viewBox=\"0 0 44.271 44.271\"><title>danger</title><path d=\"M42.355,10.833l-9.189-9.066c-1.092-1.091-2.674-1.684-4.217-1.684H14.547c-1.541,0-3.02,0.593-4.11,1.684l-8.909,9.076 C0.437,11.934,0,13.404,0,14.945v14.402c0,1.542,0.437,3.021,1.528,4.111l8.998,9.056c1.09,1.09,2.481,1.674,4.022,1.674h14.403 c1.541,0,3.021-0.584,4.111-1.674l9.295-9.071c1.09-1.09,1.914-2.555,1.914-4.097V14.944 C44.269,13.403,43.447,11.924,42.355,10.833z M22.134,32.766c-1.528,0-2.766-1.264-2.766-2.823c0-1.561,1.238-2.824,2.766-2.824 s2.767,1.264,2.767,2.824C24.9,31.502,23.662,32.766,22.134,32.766z M24.9,22.375c0,1.559-1.207,2.822-2.767,2.822 s-2.767-1.264-2.767-2.822v-11.65c0-1.559,1.207-2.824,2.767-2.824S24.9,9.166,24.9,10.724V22.375z\"/></symbol><symbol id=\"info-button\" viewBox=\"0 0 45.999 45.999\"><title>info-button</title><path d=\"M39.264,6.736c-8.982-8.981-23.545-8.982-32.528,0c-8.982,8.982-8.981,23.545,0,32.528c8.982,8.98,23.545,8.981,32.528,0 C48.245,30.281,48.244,15.719,39.264,6.736z M25.999,33c0,1.657-1.343,3-3,3s-3-1.343-3-3V21c0-1.657,1.343-3,3-3s3,1.343,3,3V33z M22.946,15.872c-1.728,0-2.88-1.224-2.844-2.735c-0.036-1.584,1.116-2.771,2.879-2.771c1.764,0,2.88,1.188,2.917,2.771 C25.897,14.648,24.746,15.872,22.946,15.872z\"/></symbol></svg>"

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _animatorjs = __webpack_require__(3);

var _frames = __webpack_require__(11);

var _frames2 = _interopRequireDefault(_frames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Animation = {};

Animation.overlay_in = [new _animatorjs.Frame(_frames2.default['wwise-overlay-in-1'], 0), new _animatorjs.Frame(_frames2.default['wwise-overlay-in-2'], 400)];

Animation.overlay_out = [new _animatorjs.Frame(_frames2.default['wwise-overlay-out-1'], 300)];

Animation.pop_in = [new _animatorjs.Frame(_frames2.default['wwise-pop-in-1'], 0), new _animatorjs.Frame(_frames2.default['wwise-pop-in-2'], { duration: 200, 'timing-function': 'ease-in' }), new _animatorjs.Frame(_frames2.default['wwise-pop-in-3'], { duration: 100, 'timing-function': 'linear' }), new _animatorjs.Frame(_frames2.default['wwise-pop-in-4'], { duration: 100, 'timing-function': 'linear' })];

Animation.pop_out = [new _animatorjs.Frame(_frames2.default['wwise-pop-out-1'], { duration: 250, 'timing-function': 'ease-in' })];

Animation.flip_in = [new _animatorjs.Frame(_frames2.default['wwise-flip-in-1'], 0), new _animatorjs.Frame(_frames2.default['wwise-flip-in-2'], 500)];

Animation.flip_out = [new _animatorjs.Frame(_frames2.default['wwise-flip-out-1'], 400)];

Animation.min_in = [new _animatorjs.Frame(_frames2.default['wwise-min-in-1'], 0), new _animatorjs.Frame(_frames2.default['wwise-min-in-2'], 350)];

Animation.min_out = [new _animatorjs.Frame(_frames2.default['wwise-min-out-1'], 400)];

var dirs = ['top', 'bottom', 'left', 'right'];
for (var i in dirs) {
	var key = dirs[i];

	Animation[key + '_in'] = [new _animatorjs.Frame(_frames2.default['wwise-' + key + '-in-1'], 0), new _animatorjs.Frame(_frames2.default['wwise-' + key + '-in-2'], { duration: 400, 'timing-function': 'ease-out' })];

	Animation[key + '_out'] = [new _animatorjs.Frame(_frames2.default['wwise-' + key + '-out-1'], { duration: 400, 'timing-function': 'ease-in' })];
}

exports.default = Animation;

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _utility = __webpack_require__(0);

var _utility2 = _interopRequireDefault(_utility);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = {};

Button.create = function (options) {
	var className = 'button' + (options.type ? ' ' + options.type : '');
	var button = _utility2.default.createDiv(className, options.text);
	button.addEventListener('click', options.onClick);
	return button;
};

exports.default = Button;

/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});
var frames = {};

// Overlay
frames['wwise-overlay-in-1'] = {
	opacity: '0'
};

frames['wwise-overlay-in-2'] = {
	opacity: '1'
};

frames['wwise-overlay-out-1'] = {
	opacity: '0'
};

// Pop
frames['wwise-pop-in-1'] = {
	transform: 'scale(0.5, 0.5)',
	'margin-top': '50px',
	opacity: '.5'
};

frames['wwise-pop-in-2'] = {
	transform: 'scale(1, 1)',
	'margin-top': '0',
	opacity: '1'
};

frames['wwise-pop-in-3'] = {
	transform: 'scale(1.05, 1.05)'
};

frames['wwise-pop-in-4'] = {
	transform: 'scale(1, 1)'
};

frames['wwise-pop-out-1'] = {
	transform: 'scale(0.25, 0.25)',
	'margin-top': '50px',
	opacity: '0'
};

// Flip

frames['wwise-flip-in-1'] = {
	transform: 'rotateX(60deg) scaleX(.5)',
	opacity: '.2'
};

frames['wwise-flip-in-2'] = {
	transform: 'none',
	opacity: '1'
};

frames['wwise-flip-out-1'] = {
	transform: 'rotateX(60deg) scaleX(.5)',
	opacity: '0'
};

// Top
frames['wwise-top-in-1'] = {
	transform: 'translateY(-30vh)',
	opacity: '.5'
};

frames['wwise-top-in-2'] = {
	transform: 'none',
	opacity: '1'
};

frames['wwise-top-out-1'] = {
	transform: 'translateY(-30vh)',
	opacity: '0'
};

// Bottom
frames['wwise-bottom-in-1'] = {
	transform: 'translateY(30vh)',
	opacity: '.5'
};

frames['wwise-bottom-in-2'] = {
	transform: 'none',
	opacity: '1'
};

frames['wwise-bottom-out-1'] = {
	transform: 'translateY(30vh)',
	opacity: '0'
};

// Left
frames['wwise-left-in-1'] = {
	transform: 'translateX(-30vw)',
	opacity: '.5'
};

frames['wwise-left-in-2'] = {
	transform: 'none',
	opacity: '1'
};

frames['wwise-left-out-1'] = {
	transform: 'translateX(-30vw)',
	opacity: '0'
};

// Right
frames['wwise-right-in-1'] = {
	transform: 'translateX(30vw)',
	opacity: '.5'
};

frames['wwise-right-in-2'] = {
	transform: 'none',
	opacity: '1'
};

frames['wwise-right-out-1'] = {
	transform: 'translateX(30vw)',
	opacity: '0'
};

// Min
frames['wwise-min-in-1'] = {
	'margin-top': '0',
	transform: 'rotateX(-60deg) scale(0.2, 1.8) translateY(80vh)',
	opacity: '.2'
};

frames['wwise-min-in-2'] = {
	transform: 'none',
	opacity: '1'
};

frames['wwise-min-out-1'] = {
	'margin-top': '30vh',
	transform: 'rotateX(-60deg) scale(0.05, 2) translateY(30vh)',
	opacity: '0'
};

exports.default = frames;

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Utility = exports.Input = exports.Progress = exports.Push = exports.Nft = exports.Modal = exports.Window = undefined;

var _window = __webpack_require__(1);

var _window2 = _interopRequireDefault(_window);

var _modal = __webpack_require__(2);

var _modal2 = _interopRequireDefault(_modal);

var _notification = __webpack_require__(5);

var _notification2 = _interopRequireDefault(_notification);

var _push = __webpack_require__(7);

var _push2 = _interopRequireDefault(_push);

var _progress = __webpack_require__(6);

var _progress2 = _interopRequireDefault(_progress);

var _input = __webpack_require__(4);

var _input2 = _interopRequireDefault(_input);

var _utility = __webpack_require__(0);

var _utility2 = _interopRequireDefault(_utility);

var _sprite = __webpack_require__(8);

var _sprite2 = _interopRequireDefault(_sprite);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Add icons
window.addEventListener('load', function () {
	var dom = document.createElement('div');

	dom.setAttribute('hidden', '');
	dom.innerHTML = _sprite2.default;
	document.body.insertBefore(dom, document.body.firstChild);
});

exports.Window = _window2.default;
exports.Modal = _modal2.default;
exports.Nft = _notification2.default;
exports.Push = _push2.default;
exports.Progress = _progress2.default;
exports.Input = _input2.default;
exports.Utility = _utility2.default;

/***/ })
/******/ ]);
});